

/*
 * This file is provided under a dual BSD/GPLv2 license.  When using or 
 *   redistributing this file, you may do so under either license.
 * 
 *   GPL LICENSE SUMMARY
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of version 2 of the GNU General Public License as
 *   published by the Free Software Foundation.
 * 
 *   This program is distributed in the hope that it will be useful, but 
 *   WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 *   General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License 
 *   along with this program; if not, write to the Free Software 
 *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *   The full GNU General Public License is included in this distribution 
 *   in the file called LICENSE.GPL.
 * 
 *   Contact Information:
 *   Intel Corporation
 * 
 *   BSD LICENSE 
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 *   All rights reserved.
 * 
 *   Redistribution and use in source and binary forms, with or without 
 *   modification, are permitted provided that the following conditions 
 *   are met:
 * 
 *     * Redistributions of source code must retain the above copyright 
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright 
 *       notice, this list of conditions and the following disclaimer in 
 *       the documentation and/or other materials provided with the 
 *       distribution.
 *     * Neither the name of Intel Corporation nor the names of its 
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 * 
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 *  version: Embedded.L.1.0.34
 */

/*****************************************************************************
 * Module name:
 *    1588
 *
 * Abstract:
 *    This header file is to be included by the files which need the 1588
 *    module ioctl commands 
 *
 * Contents:
 *    No exported items in this file
 *
 * Revision:
 *    TBD
 *
 *****************************************************************************/

#ifndef LINUX_IOCTLS_H
#define LINUX_IOCTLS_H

//
// 1588 module ioctl command codes
//

#define TS_IOCTL_BASE 0xCD
#define IOCTL_PORT_CONFIG_SET _IOW(TS_IOCTL_BASE, 0, IxTimeSyncAccPortCfgIoctl)   
#define IOCTL_PORT_CONFIG_GET _IOWR(TS_IOCTL_BASE, 1, IxTimeSyncAccPortCfgIoctl)
#define IOCTL_RX_POLL _IOWR(TS_IOCTL_BASE, 2, IxTimeSyncAccRxTxPollIoctl)   
#define IOCTL_TX_POLL _IOWR(TS_IOCTL_BASE, 3, IxTimeSyncAccRxTxPollIoctl)
#define IOCTL_CAN_POLL _IOWR(TS_IOCTL_BASE, 4, IxTimeSyncAccCANPollIoctl)   
#define IOCTL_SYS_TIME_GET _IOR(TS_IOCTL_BASE, 5, IxTimeSyncAccTimeValue)
#define IOCTL_SYS_TIME_SET _IOW(TS_IOCTL_BASE, 6, IxTimeSyncAccTimeValue)   
#define IOCTL_TICK_RATE_SET _IOW(TS_IOCTL_BASE, 7, UINT32)
#define IOCTL_TICK_RATE_GET _IOR(TS_IOCTL_BASE, 8, UINT32)   
#define IOCTL_TARG_TIME_INTRPT_ENABLE _IO(TS_IOCTL_BASE, 9)
#define IOCTL_TARG_TIME_INTRPT_DISABLE _IO(TS_IOCTL_BASE, 10)   
#define IOCTL_TARG_TIME_POLL _IOR(TS_IOCTL_BASE, 11, IxTimeSyncAccTimePollIoctl)
#define IOCTL_TARG_TIME_SET _IOW(TS_IOCTL_BASE, 12, IxTimeSyncAccTimeValue)   
#define IOCTL_TARG_TIME_GET _IOR(TS_IOCTL_BASE, 13, IxTimeSyncAccTimeValue)
#define IOCTL_AUX_TIME_INTRPT_ENABLE _IOW(TS_IOCTL_BASE, 14, IxTimeSyncAccAuxMode)   
#define IOCTL_AUX_TIME_INTRPT_DISABLE _IOW(TS_IOCTL_BASE, 15, IxTimeSyncAccAuxMode)
#define IOCTL_AUX_TIME_POLL _IOWR(TS_IOCTL_BASE, 16, IxTimeSyncAccTimePollIoctl)   
#define IOCTL_RESET _IO(TS_IOCTL_BASE, 17)
#define IOCTL_CHNL_RESET _IOW(TS_IOCTL_BASE, 18, IxTimeSyncAcc1588PTPPort)   
#define IOCTL_STATS_GET _IOR(TS_IOCTL_BASE, 19, IxTimeSyncAccStats)
#define IOCTL_STATS_RESET _IO(TS_IOCTL_BASE, 20)
#define IOCTL_SHOW_ALL _IO(TS_IOCTL_BASE, 21)   
#define IOCTL_AUX_TARG_TIME_INTRPT_ENABLE _IO(TS_IOCTL_BASE, 22)
#define IOCTL_AUX_TARG_TIME_INTRPT_DISABLE _IO(TS_IOCTL_BASE, 23)
#define IOCTL_AUX_TARG_TIME_POLL _IOR(TS_IOCTL_BASE, 24, IxTimeSyncAccTimePollIoctl)   
#define IOCTL_AUX_TARG_TIME_SET _IOW(TS_IOCTL_BASE, 25, IxTimeSyncAccTimeValue)
#define IOCTL_AUX_TARG_TIME_GET _IOR(TS_IOCTL_BASE, 26, IxTimeSyncAccTimeValue)   
#define IOCTL_PULSE_PER_SEC_INTRPT_ENABLE _IO(TS_IOCTL_BASE, 27)
#define IOCTL_PULSE_PER_SEC_INTRPT_DISABLE _IO(TS_IOCTL_BASE, 28)   
#define IOCTL_TARG_TIME_NOTIFY _IOR(TS_IOCTL_BASE, 29, IxTimeSyncAccTimeValue)
#define IOCTL_AUX_TIME_NOTIFY _IOR(TS_IOCTL_BASE, 30, IxTimeSyncAccAuxTimeIoctl)   
#define IOCTL_AUX_TARG_TIME_NOTIFY _IOR(TS_IOCTL_BASE, 31, IxTimeSyncAccTimeValue)
#define IOCTL_PULSE_PER_SEC_NOTIFY _IOR(TS_IOCTL_BASE, 32, UINT32)   
#define IOCTL_TARG_TIME_CLR_NOTIFY _IO(TS_IOCTL_BASE, 33)
#define IOCTL_AUX_TIME_CLR_NOTIFY _IO(TS_IOCTL_BASE, 34)
#define IOCTL_AUX_TARG_TIME_CLR_NOTIFY _IO(TS_IOCTL_BASE, 35)   
#define IOCTL_PULSE_PER_SEC_CLR_NOTIFY _IO(TS_IOCTL_BASE, 36)
#define IOCTL_PULSE_PER_SEC_TIME_GET _IOR(TS_IOCTL_BASE, 37, UINT32)
#define IOCTL_PULSE_PER_SEC_TIME_SET _IOW(TS_IOCTL_BASE, 38, UINT32)
#define IOCTL_PORT_VERSION_SET _IOW(TS_IOCTL_BASE, 39, IxTimeSyncAccVersionIoctl)   
#define IOCTL_PORT_VERSION_GET _IOWR(TS_IOCTL_BASE, 40, IxTimeSyncAccVersionIoctl)   
#define IOCTL_PORT_OPERATION_MODE_SET _IOW(TS_IOCTL_BASE, 41, IxTimeSyncAccOperationModeIoctl)   
#define IOCTL_PORT_OPERATION_MODE_GET _IOWR(TS_IOCTL_BASE, 42, IxTimeSyncAccOperationModeIoctl)   

#endif


