/*****************************************************************************
 * %LICENSE_DUAL%
 * This file is provided under a dual BSD/GPLv2 license.  When using or 
 *   redistributing this file, you may do so under either license.
 * 
 *   GPL LICENSE SUMMARY
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of version 2 of the GNU General Public License as
 *   published by the Free Software Foundation.
 * 
 *   This program is distributed in the hope that it will be useful, but 
 *   WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 *   General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License 
 *   along with this program; if not, write to the Free Software 
 *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *   The full GNU General Public License is included in this distribution 
 *   in the file called LICENSE.GPL.
 * 
 *   Contact Information:
 *   Intel Corporation
 * 
 *   BSD LICENSE 
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 *   All rights reserved.
 * 
 *   Redistribution and use in source and binary forms, with or without 
 *   modification, are permitted provided that the following conditions 
 *   are met:
 * 
 *     * Redistributions of source code must retain the above copyright 
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright 
 *       notice, this list of conditions and the following disclaimer in 
 *       the documentation and/or other materials provided with the 
 *       distribution.
 *     * Neither the name of Intel Corporation nor the names of its 
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 * 
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 *  version: Embedded.L.1.0.34
 *****************************************************************************/

#ifndef __ICP_CAN_USER_H__
#define __ICP_CAN_USER_H__

/*****************************************************************************
 * Device IO control codes.
 *****************************************************************************/

#define MAGIC				0xdd

#define ICP_CAN_IO_RESET		_IO(MAGIC, 0)

#define ICP_CAN_IO_RUN			_IO(MAGIC, 1)
#define ICP_CAN_IO_STOP			_IO(MAGIC, 2)
#define ICP_CAN_IO_RUN_GET		_IOR(MAGIC, 3, icp_can_run_mode_t)

#define ICP_CAN_IO_FILTER		_IOW(MAGIC, 4, icp_can_rx_filter_t *)
#define ICP_CAN_IO_FILTER_GET	_IOR(MAGIC, 5, icp_can_rx_filter_t)

#define ICP_CAN_IO_CUSTOM		_IOW(MAGIC, 6, icp_can_timing_t *)
#define ICP_CAN_IO_SIMPLE		_IOW(MAGIC, 7, icp_can_baud_t)
#define ICP_CAN_IO_TIMING_GET	_IOR(MAGIC, 8, icp_can_timing_t *)

#define ICP_CAN_IO_BLOCK		_IO(MAGIC, 9)
#define ICP_CAN_IO_NON_BLOCK	_IO(MAGIC, 10)
#define ICP_CAN_IO_BLOCK_GET	_IOR(MAGIC, 11, unsigned int)

#define ICP_CAN_IO_LISTEN		_IO(MAGIC, 12)
#define ICP_CAN_IO_ACTIVE		_IO(MAGIC, 13)
#define ICP_CAN_IO_LISTEN_GET	_IOR(MAGIC, 14, icp_can_listen_mode_t)

#define ICP_CAN_IO_ARBITER_ROUND_ROBIN	_IO(MAGIC, 15)
#define ICP_CAN_IO_ARBITER_FIXED_PRIORITY _IO(MAGIC, 16)
#define ICP_CAN_IO_ARBITER_GET		_IOR(MAGIC, 17, icp_can_arbiter_t)

#define ICP_CAN_IO_ERROR_STATS_GET	_IOR(MAGIC, 18, icp_can_error_t *)

#define ICP_CAN_IO_RESTART_MODE_AUTO	_IO(MAGIC, 19)
#define ICP_CAN_IO_RESTART_MODE_MANUAL	_IO(MAGIC, 20)
#define ICP_CAN_IO_RESTART_MODE_GET	_IOR(MAGIC, 21, icp_can_auto_restart_t)

#define ICP_CAN_IO_BUFFER_LINK_SET	_IO(MAGIC, 22)
#define ICP_CAN_IO_BUFFER_LINK_CLEAR	_IO(MAGIC, 23)
#define ICP_CAN_IO_BUFFER_LINK_GET	_IOR(MAGIC, 24, unsigned int)

#define ICP_CAN_IO_RX_ENABLE_SET	_IO(MAGIC, 25)
#define ICP_CAN_IO_RX_ENABLE_CLEAR	_IO(MAGIC, 26)
#define ICP_CAN_IO_RX_ENABLE_GET	_IOR(MAGIC, 27, unsigned int)

#define ICP_CAN_IO_TX_ENABLE_SET	_IO(MAGIC, 28)
#define ICP_CAN_IO_TX_ENABLE_CLEAR	_IO(MAGIC, 29)
#define ICP_CAN_IO_TX_ENABLE_GET	_IOR(MAGIC, 30, unsigned int)


#endif /* __ICP_CAN_USER_H__ */
