
/*
 * This file is provided under a dual BSD/GPLv2 license.  When using or 
 *   redistributing this file, you may do so under either license.
 * 
 *   GPL LICENSE SUMMARY
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of version 2 of the GNU General Public License as
 *   published by the Free Software Foundation.
 * 
 *   This program is distributed in the hope that it will be useful, but 
 *   WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 *   General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License 
 *   along with this program; if not, write to the Free Software 
 *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *   The full GNU General Public License is included in this distribution 
 *   in the file called LICENSE.GPL.
 * 
 *   Contact Information:
 *   Intel Corporation
 * 
 *   BSD LICENSE 
 * 
 *   Copyright(c) 2007,2008 Intel Corporation. All rights reserved.
 *   All rights reserved.
 * 
 *   Redistribution and use in source and binary forms, with or without 
 *   modification, are permitted provided that the following conditions 
 *   are met:
 * 
 *     * Redistributions of source code must retain the above copyright 
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright 
 *       notice, this list of conditions and the following disclaimer in 
 *       the documentation and/or other materials provided with the 
 *       distribution.
 *     * Neither the name of Intel Corporation nor the names of its 
 *       contributors may be used to endorse or promote products derived 
 *       from this software without specific prior written permission.
 * 
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 *  version: Embedded.L.1.0.34
 */

/*****************************************************************************
 * Module name:
 *    gpio
 *
 * Abstract:
 *    This header file is to be included by the files which need the gpio
 *    module ioctl commands 
 *
 * Contents:
 *    No exported items in this file
 *
 * Revision:
 *    TBD
 *
 *****************************************************************************/

#ifndef LINUX_IOCTLS_H
#define LINUX_IOCTLS_H


// GPIO ioctls

#define GPIO_IOCTL_BASE 0xCD
#define IOCTL_GET_PIN_INFO _IOWR(GPIO_IOCTL_BASE, 0, gpio_ioctl_t)   
#define IOCTL_SET_TO_ALTERNATIVE _IOWR(GPIO_IOCTL_BASE, 1, gpio_ioctl_t)
#define IOCTL_SET_TO_GPIO _IOWR(GPIO_IOCTL_BASE, 2, gpio_ioctl_t)
#define IOCTL_SET_AS_INPUT _IOWR(GPIO_IOCTL_BASE, 3, gpio_ioctl_t)
#define IOCTL_SET_AS_OUTPUT _IOWR(GPIO_IOCTL_BASE, 4, gpio_ioctl_t)
#define IOCTL_SET_HIGH _IOWR(GPIO_IOCTL_BASE, 5, gpio_ioctl_t)
#define IOCTL_SET_LOW _IOWR(GPIO_IOCTL_BASE, 6, gpio_ioctl_t)
#define IOCTL_START_BLINK _IOWR(GPIO_IOCTL_BASE, 7, gpio_ioctl_t)
#define IOCTL_STOP_BLINK _IOWR(GPIO_IOCTL_BASE, 8, gpio_ioctl_t)
#define IOCTL_INVERTED_INPUT _IOWR(GPIO_IOCTL_BASE, 9, gpio_ioctl_t)
#define IOCTL_NONINVERTED_INPUT _IOWR(GPIO_IOCTL_BASE, 10, gpio_ioctl_t)
#define IOCTL_READ_LEVEL _IOWR(GPIO_IOCTL_BASE, 11, gpio_ioctl_t)
#define IOCTL_READ_GPIO_USE_SEL1_DWORD _IOWR(GPIO_IOCTL_BASE, 12, gpio_ioctl_t)
#define IOCTL_READ_GP_IO_SEL1_DWORD _IOWR(GPIO_IOCTL_BASE, 13, gpio_ioctl_t)
#define IOCTL_READ_GP_LVL1_DWORD _IOWR(GPIO_IOCTL_BASE, 14, gpio_ioctl_t)
#define IOCTL_READ_GPO_BLINK_DWORD _IOWR(GPIO_IOCTL_BASE, 15, gpio_ioctl_t)				
#define IOCTL_READ_GPI_INV_DWORD _IOWR(GPIO_IOCTL_BASE, 16, gpio_ioctl_t)
#define IOCTL_READ_GPIO_USE_SEL2_DWORD _IOWR(GPIO_IOCTL_BASE, 17, gpio_ioctl_t)
#define IOCTL_READ_GP_IO_SEL2_DWORD _IOWR(GPIO_IOCTL_BASE, 18, gpio_ioctl_t)
#define IOCTL_READ_GP_LVL2_DWORD _IOWR(GPIO_IOCTL_BASE, 19, gpio_ioctl_t)
#define IOCTL_WRITE_GPIO_USE_SEL1_DWORD _IOWR(GPIO_IOCTL_BASE, 20, gpio_ioctl_t)
#define IOCTL_WRITE_GP_IO_SEL1_DWORD _IOWR(GPIO_IOCTL_BASE, 21, gpio_ioctl_t)
#define IOCTL_WRITE_GP_LVL1_DWORD _IOWR(GPIO_IOCTL_BASE, 22, gpio_ioctl_t)
#define IOCTL_WRITE_GPO_BLINK_DWORD _IOWR(GPIO_IOCTL_BASE, 23, gpio_ioctl_t)				
#define IOCTL_WRITE_GPI_INV_DWORD _IOWR(GPIO_IOCTL_BASE, 24, gpio_ioctl_t)
#define IOCTL_WRITE_GPIO_USE_SEL2_DWORD _IOWR(GPIO_IOCTL_BASE, 25, gpio_ioctl_t)
#define IOCTL_WRITE_GP_IO_SEL2_DWORD _IOWR(GPIO_IOCTL_BASE, 26, gpio_ioctl_t)
#define IOCTL_WRITE_GP_LVL2_DWORD _IOWR(GPIO_IOCTL_BASE, 27, gpio_ioctl_t)

/**
 *****************************************************************************
 * @ingroup GPIO
 * GPIO control ioctl.
 * @description
 *    This structure is used to exchange information between the user and the
 *    GPIO reference driver. 
 * @see  gpio_ioctl_t
 *****************************************************************************/
typedef struct gpio_ioctl_s
{
	unsigned int signal;
	unsigned int data;
	char buff[512];
} gpio_ioctl_t;


#endif


